//----------------------------------------------------------------------------
//	Main.c  
//  USB Smart Button Replacemnt Firmware
//
//	Author:   Nick Graber
//  Created:   03.01.2012
//----------------------------------------------------------------------------

#include <m8c.h>        // part specific constants and macros
#include "PSoCAPI.h"    // PSoC API definitions for all User Modules
#include <delay.h>
#include <string.h>

#define RELOAD_VALUE 500 // Set timer interval to 4095 input cycles of the input clock


//*******************URL to be launched on button press*******************

const char URL1[100] = "http://www.graber.me\n"; //First URL  Open On Press
const char URL2[100] = "http://www.hackaday.com\n";    //Second URL Opne On HOLD 1/2 second
const char *URL[2] = { URL1, URL2 }; //URL to be sent over USB
unsigned char URL_Select = 0;

//************************************************************************

int x = 0; //For loop Counter


const unsigned char ascii_scan[128][2] = {
	0x00,0x00,     // null
	0x00,0x00,     // start of heading
	0x00,0x00,     // start of text
	0x00,0x00,     // end of text
	0x00,0x00,     // end of transmission
	0x00,0x00,     // enquiry
	0x00,0x00,     // acknowledge
	0x00,0x00,     // bell
	0x2A,0x00,     // backspace
	0x2B,0x00,     // horizontal tab
	0x28,0x00,     // new line
	0x00,0x00,     // vertical tab
	0x00,0x00,     // new page
	0x00,0x00,     // carriage return
	0x00,0x00,     // shift out
	0x00,0x00,     // shift in
	0x00,0x00,     // data link escape
	0x00,0x00,     // device control 1
	0x00,0x00,     // device control 2
	0x00,0x00,     // device control 3
	0x00,0x00,     // device control 4
	0x00,0x00,     // negative acknowledge
	0x00,0x00,     // synchronous idle
	0x00,0x00,     // end of trans. block
	0x00,0x00,     // cancel
	0x00,0x00,     // end of medium
	0x00,0x00,     // substitute
	0x29,0x00,     // escape
	0x00,0x00,     // file separator
	0x00,0x00,     // group separator
	0x00,0x00,     // record separator
	0x00,0x00,     // unit separator
	0x2C,0x00,     // space
	0x1E,0x01,     // !
	0x34,0x01,     // "
	0x20,0x01,     // #
	0x21,0x01,     // $
	0x22,0x01,     // %
	0x24,0x01,     // &
	0x34,0x00,     // '
	0x26,0x01,     // (
	0x27,0x01,     // )
	0x25,0x01,     // *
	0x2E,0x01,     // +
	0x36,0x00,     // ,
	0x2D,0x00,     // -
	0x37,0x00,     // .
	0x38,0x00,     // /
	0x27,0x00,     // 0
	0x1E,0x00,     // 1
	0x1F,0x00,     // 2
	0x20,0x00,     // 3
	0x21,0x00,     // 4
	0x22,0x00,     // 5
	0x23,0x00,     // 6
	0x24,0x00,     // 7
	0x25,0x00,     // 8
	0x26,0x00,     // 9
	0x33,0x01,     // :
	0x33,0x00,     // ;
	0x36,0x01,     // <
	0x2E,0x00,     // =
	0x37,0x01,     // >
	0x38,0x01,     // ?
	0x1F,0x01,     // @
	0x04,0x01,     // A
	0x05,0x01,     // B
	0x06,0x01,     // C
	0x07,0x01,     // D
	0x08,0x01,     // E
	0x09,0x01,     // F
	0x0A,0x01,     // G
	0x0B,0x01,     // H
	0x0C,0x01,     // I
	0x0D,0x01,     // J
	0x0E,0x01,     // K
	0x0F,0x01,     // L
	0x10,0x01,     // M
	0x11,0x01,     // N
	0x12,0x01,     // O
	0x13,0x01,     // P
	0x14,0x01,     // Q
	0x15,0x01,     // R
	0x16,0x01,     // S
	0x17,0x01,     // T
	0x18,0x01,     // U
	0x19,0x01,     // V
	0x1A,0x01,     // W
	0x1B,0x01,     // X
	0x1C,0x01,     // Y
	0x1D,0x01,     // Z
	0x2F,0x00,     // [
	0x31,0x00,     // "\"
	0x30,0x00,     // ]
	0x23,0x01,     // ^
	0x2D,0x01,     // _
	0x35,0x00,     // `
	0x04,0x00,     // a
	0x05,0x00,     // b
	0x06,0x00,     // c
	0x07,0x00,     // d
	0x08,0x00,     // e
	0x09,0x00,     // f
	0x0A,0x00,     // g
	0x0B,0x00,     // h
	0x0C,0x00,     // i
	0x0D,0x00,     // j
	0x0E,0x00,     // k
	0x0F,0x00,     // l
	0x10,0x00,     // m
	0x11,0x00,     // n
	0x12,0x00,     // o
	0x13,0x00,     // p
	0x14,0x00,     // q
	0x15,0x00,     // r
	0x16,0x00,     // s
	0x17,0x00,     // t
	0x18,0x00,     // u
	0x19,0x00,     // v
	0x1A,0x00,     // w
	0x1B,0x00,     // x
	0x1C,0x00,     // y
	0x1D,0x00,     // z
	0x2F,0x01,     // {
	0x31,0x01,     // |
	0x30,0x01,     // }
	0x35,0x01,     // ~
	0x4C,0x00,     // DEL
};

const unsigned char pwm_sine[256] = {
	90,		93,		97,		99,		101,	103,	105,	108,
	110,	112,	114,	116,	118,	120,	122,	124,
	126,	128,	130,	132,	134,	136,	138,	140,
	142,	144,	145,	147,	149,	150,	152,	154,
	155,	157,	158,	160,	161,	162,	164,	165,
	166,	167,	168,	169,	170,	171,	172,	173,
	174,	175,	175,	176,	177,	177,	178,	178,
	179,	179,	179,	180,	180,	180,	180,	180,
	180,	180,	180,	180,	179,	179,	179,	178,
	178,	177,	177,	176,	175,	175,	174,	173,
	172,	171,	170,	169,	168,	167,	166,	165,
	164,	162,	161,	160,	158,	157,	155,	154,
	152,	150,	149,	147,	145,	144,	142,	140,
	138,	136,	134,	132,	130,	128,	126,	124,
	122,	120,	118,	116,	114,	112,	110,	108,
	105,	103,	101,	99,		97,		94,		92,		90,
	88,		86,		83,		81,		79,		77,		75,		72,
	70,		68,		66,		64,		62,		60,		58,		56,
	54,		52,		50,		48,		46,		44,		42,		40,
	38,		36,		35,		33,		31,		30,		28,		26,
	25,		23,		22,		20,		19,		18,		16,		15,
	14,		13,		12,		11,		10,		9,		8,		7,
	6,		5,		5,		4,		3,		3,		2,		2,
	1,		1,		1,		0,		0,		0,		0,		0,
	0,		0,		0,		0,		1,		1,		1,		2,
	2,		3,		3,		4,		5,		5,		6,		7,
	8,		9,		10,		11,		12,		13,		14,		15,
	16,		18,		19,		20,		22,		23,		25,		26,
	28,		30,		31,		33,		35,		36,		38,		40,
	42,		44,		46,		48,		50,		52,		54,		56,
	58,		60,		62,		64,		66,		68,		70,		72,
	75,		77,		79,		81,		83,		86,		88,		90
};


struct USB_HID_Keyboard {
		// Compiler Enumerates Bit-fields Backwards :(
        unsigned char RightGUI : 1;		// Bit 7
        unsigned char RightAlt : 1;		// Bit 6
        unsigned char RightShift : 1;	// Bit 5
        unsigned char RightControl : 1;	// Bit 4
        unsigned char LeftGUI : 1;		// Bit 3
        unsigned char LeftAlt : 1;		// Bit 2
        unsigned char LeftShift : 1;  	// Bit 1		
        unsigned char LeftControl : 1;  // Bit 0		
        unsigned char OEMReserved;
        unsigned char ScanCode[5];
}Keyboard;

//Used to make our structure look like an array of unsigned chars
unsigned char *pKeyboard = (unsigned char *)&Keyboard;

//PWM Variables
unsigned char PWM_RED_Counter = 0;
unsigned char PWM_RED_Period = 0;
unsigned char PWM_GREEN_Counter = 0;
unsigned char PWM_GREEN_Period = 0;
unsigned char PWM_BLUE_Counter = 0;
unsigned char PWM_BLUE_Period = 0;
unsigned char SineSpeed = 0;
unsigned char SineIndex = 0;


void main(void)
{

	M8C_EnableGInt; //Enable Global Interrupts
	PITIMER12_1_Start(RELOAD_VALUE); // Start timer module with defined divider 24Mhz / 4 / 500 == 12Khz
	PITIMER12_1_EnableInt(); // Enable timer module interrupts
	
	USB_Start(0); //Start USB Operation using device 0
	while (!USB_bGetConfiguration()); //Wait for Device to enumerate

	//Wait for button to be pressed.
     while(1){ 
		if(!(PRT0DR & Button0_MASK)){
			Delay10msTimes(50);
			if(!(PRT0DR & Button0_MASK)){
				URL_Select = 1;
			}
			else{
				URL_Select = 0;
			}
			
			Keyboard.ScanCode[0] = ascii_scan['r'][0];
			Keyboard.LeftGUI = 1;
			while (!USB_bGetEPState(1)); //Wait for buffer to be empty
			USB_LoadEP (1, pKeyboard, 8);  //Send Windows r to open Run Box
			Keyboard.ScanCode[0] = 0x00;
			Keyboard.LeftGUI = 0;
			while (!USB_bGetEPState(1)); //Wait for buffer to be empty
			USB_LoadEP (1, pKeyboard, 8); //Send 0x00 to indicate button release
			Delay10msTimes(50);
			for(x = 0; x < cstrlen(URL[URL_Select]); x++){
				Keyboard.ScanCode[0] = ascii_scan[URL[URL_Select][x]][0];
				if(ascii_scan[URL[URL_Select][x]][1]){
					Keyboard.LeftShift = 1;
				} //end if
				else{
					Keyboard.LeftShift = 0;
				} // end else
				while (!USB_bGetEPState(1)); //Wait for buffer to be empty
				USB_LoadEP (1, pKeyboard, 8); //Send char from string
				Keyboard.ScanCode[0] = 0x00;
				Keyboard.LeftShift = 0;
				while (!USB_bGetEPState(1)); //Wait for buffer to be empty
				USB_LoadEP (1, pKeyboard, 8); //Send 0x00 to indicate button release
			
			} // end for
			Delay10msTimes(255);
		} // End if
	} // End While
}  //End Main

//Tell Compiler where Interupt Vector is and the name of our ISR
#pragma interrupt_handler PITIMER12_1_ISR
void PITIMER12_1_ISR(void){

//used as an 8 bit buffer to ensure rollover when adding 120deg for sine wave phase shift
unsigned char Sine_Index_Temp =0; 

	//PWM RED Start
	PWM_RED_Counter ++;
	if(PWM_RED_Counter >= 180){
		PWM_RED_Counter = 0;
	}
	
	if(PWM_RED_Counter <= PWM_RED_Period){
		PRT1DR &= ~LED_RED_MASK;
	}
	else{
		PRT1DR |= LED_RED_MASK;
	}
	//PWM RED Stop
	
	
	//PWM GREEN Start
	PWM_GREEN_Counter ++;
	if(PWM_GREEN_Counter >= 180){
		PWM_GREEN_Counter = 0;
	}
	
	if(PWM_GREEN_Counter <= PWM_GREEN_Period){
		PRT1DR &= ~LED_GREEN_MASK;
	}
	else{
		PRT1DR |= LED_GREEN_MASK;
	}
	//PWM GREEN Stop
	
	
	//PWM BLUE Start
	PWM_BLUE_Counter ++;	
	if(PWM_BLUE_Counter >= 180){
		PWM_BLUE_Counter = 0;
	}
	
	if(PWM_BLUE_Counter <= PWM_BLUE_Period){
		PRT1DR &= ~LED_BLUE_MASK;
	}
	else{
		PRT1DR |= LED_BLUE_MASK;
	}
	//PWM BLUE Stop
	
	//Sine Table Lookup START
	//SineSpeed determins how fast we go through the sine table.
	if(SineSpeed == 200){
		SineSpeed = 0;
		SineIndex ++;
		Sine_Index_Temp = SineIndex;
		PWM_RED_Period = pwm_sine[Sine_Index_Temp];
		Sine_Index_Temp += 85; // Add offset of 120deg. The sine table is in 1.406deg increments.
		PWM_GREEN_Period = pwm_sine[Sine_Index_Temp];
		Sine_Index_Temp += 85; // Add offset of 120deg. Now we are at 240 deg phase shift.
		PWM_BLUE_Period = pwm_sine[Sine_Index_Temp];
	}
	SineSpeed ++;
	//Sine Table Lookup END
		
	
	

}

